# encoding: UTF-8
#
# file "sj_xml_to_enscape_path_video/curve_to_enscape_path_video.rb"

## Charge tous les scripts dont ce module dépend.
    ## Note: Le chemin est relatif à la racine de tous les plugins.
    require 'sketchup'
    require 'json'
    require 'fileutils'
      
    ## Ajouter ici les fichiers contenant les commandes
        ## Decommenter la ligne
    #require 'sj_attribute_report/NOM DU FICHIER.rb'      #EDIT
      
# Espace de noms de l'auteur.
module SimJoubert
      
  # Espace de noms du plugin.
  module SJ_XML_TO_ENSCAPE_PATH_VIDEO 

    # Constante du nom du dictionnaire ou seront stockées les préférences de préfix
    CDICT = 'sj_xml_to_enscape_path_video'


    def self.validation_proc_group(num=999)
      model = Sketchup.active_model
      sel = model.selection
      groups = sel.grep(Sketchup::Group)
      if groups.length > num || groups.length == 0
        return false
      elsif num == 1
        if JSON.parse(groups[0].get_attribute(CDICT,'keyframes',"{}")) == {}
          return false
        else
          return true
        end
      end
    end

    def self.validation_proc_curve()
      model = Sketchup.active_model
      sel = model.selection
      edges = sel.grep(Sketchup::Edge)
      if edges.length ==0
        return false
      else
        curve = edges[0].curve
        if curve == nil
          return false
        else
          return true
        end
      end
    end




    def self.preferences_path(group, targets, cam_num)

      model = group.model
      pid = group.persistent_id
        
        #on récupère les préférences enregistrée dans le dictionnaire sj_components_to_scenes du model
        prefs =JSON.parse(model.get_attribute( CDICT, pid, "{}"))
        
        if prefs == {}
            prefs = {
              'path_name' => 'path name',
              'timestamp_start' => 2.0,
              'timestamp_middle' => 5.0,
              'timestamp_end' => 2.0,
              'hour_start' => 8.0,
              'hour_middle' => 14.0,
              'hour_end' => 22.0,
              'fieldOfViewRad' => 60,
              'focalPoint' => TRANSLATE['Yes'],
              'shakyCam' => TRANSLATE['No'],
              'easingInOut' => TRANSLATE['Yes'],
              'mode' => TRANSLATE['Forward'],
              'addScene' =>TRANSLATE['No'],
              'prefixScene' =>'EKF'
            }
        end
        
        # initialisation formulaire

        prompts = [
          TRANSLATE["Name of this video path ?"],
          TRANSLATE['Timestamp start (second)'],
          TRANSLATE['Timestamp middle (second)'],
          TRANSLATE['Timestamp end (second)'],
          TRANSLATE['Hour start (hour)'],
          TRANSLATE['Hour middle (hour)'],
          TRANSLATE['Hour end (hour)'],
          TRANSLATE['Field of view (degrees)'],
          TRANSLATE['Focal point on the target ?'],
          TRANSLATE['Path video mode'],
          TRANSLATE['Create Sketchup scenes'],
          TRANSLATE['Prefix name for scenes']
        ]
        targets_num = (targets['start'] == nil && targets['middle'] == nil && targets['end'] == nil ? 0 : 1) 
        mode_list = (targets_num == 0 ? TRANSLATE['Forward']+'|'+TRANSLATE['Reverse'] : TRANSLATE['Forward']+'|'+TRANSLATE['Reverse']+'|'+TRANSLATE['Traveling']+'|'+TRANSLATE['Panorama'])
        list = [
          "",
          "",
          "",
          "",
          "",
          "",
          "",
          "",
          TRANSLATE['Yes']+'|'+TRANSLATE['No'],
          mode_list,
          TRANSLATE['Yes']+'|'+TRANSLATE['No'],
          ""
        ]
        defaults = [
          prefs['path_name'],
          prefs['timestamp_start'],
          prefs['timestamp_middle'],
          prefs['timestamp_end'],
          prefs['hour_start'],
          prefs['hour_middle'],
          prefs['hour_end'],
          prefs['fieldOfViewRad'],
          prefs['focalPoint'],
          prefs['mode'],
          prefs['addScene'],
          prefs['prefixScene']
        ]
        titre1 = TRANSLATE["Enscape video path settings"]
        titre2 = TRANSLATE["Keyframes"]
        titre3 = "#{titre1} (#{cam_num.to_s} #{titre2})"
        input = UI.inputbox(prompts, defaults, list, titre3)

        # Si le bouton cancel est cliqué input = false
        # Donc sauf si input == false
        unless input == false
            ## On récupère les valeurs saisies dans la boîte de dialogue

            prefs = {
                'path_name' => input[0],
                'timestamp_start' => input[1],
                'timestamp_middle' => input[2],
                'timestamp_end' => input[3],
                'hour_start' => input[4],
                'hour_middle' => input[5],
                'hour_end' => input[6],
                'fieldOfViewRad' => input[7],
                'focalPoint' => input[8],
                'mode' => input[9],
                'addScene' => input[10],
                'prefixScene' => input[11]
            }

            #On enregistre les parametres saisiesdans le dictionnaire sj_xml_to_enscape_path_video du model

            model.set_attribute( CDICT, pid, prefs.to_json)
            puts "Preferences sauvegardées dans dictionnaire"
            puts prefs
        else
            
            prefs = {}
            puts "formulaire préferences annuler par l'utilisateur"
                                
        end
        
        return prefs

    end #fin de preferences_path()

    def self.erase_scenes(group)
      model = Sketchup.active_model
      pages = model.pages
      scenes_pid = group.get_attribute(CDICT, "scenes_pid", [])
      scenes_num = scenes_pid.length
      unless scenes_num == 0
        scenes = scenes_pid.map{|pid| model.find_entity_by_persistent_id(pid)}
        scenes.each{|scene| pages.erase(scene)}
        scenes_pid = group.set_attribute(CDICT, "scenes_pid", [])
     
      end
      return scenes_pid
    end


   

    def self.create_text(group, curve, mode, titre)
      text_pid_o = group.get_attribute(CDICT, "text_pid", nil).to_i
      texts = group.entities.grep(Sketchup::Text)
      text_o = texts.select{|t| t.persistent_id == text_pid_o}
      unless text_o == []
        text_o[0].erase!
      end
      edge = curve.edges[0]
      point = edge.start.position
      path = [group, edge]
      vector = Geom::Vector3d.new(0, 0, 1.m)
      text_value = "Enscape Path Vidéo "+ mode + "\n" + titre
      text = group.entities.add_text(text_value, [path, point], vector)
      case mode
      when TRANSLATE['Forward']
        color = Sketchup::Color.new(0, 153, 0)        
      when TRANSLATE['Reverse']
        color = Sketchup::Color.new(204, 51, 0)        
      when TRANSLATE['Traveling']
        color = Sketchup::Color.new(255, 0, 127)        
      else 
        color = Sketchup::Color.new(127, 0, 255)
      end
      text.material = color
      text_layer = Sketchup.active_model.layers.add("Camera_Path_Name")
      text.layer = text_layer
      text_pid = text.persistent_id
      group.set_attribute(CDICT, "text_pid", text_pid)
      curve.edges.each{|e| e.material = color}
      return text

    end

    def self.add_style(page)
      url = Sketchup.find_support_file("sj_xml_enscape_path_video.style", "Plugins/" + FOLDER + "/skp/")
      styles = Sketchup.active_model.styles
      style_o = styles.selected_style
      status = styles.add_style(url, false)
      style = styles.select{|s| s.name == "Style sj_xml_enscape_path_video"}[0]
      styles.selected_style = style
      page.use_style = style
      flag = PAGE_USE_RENDERING_OPTIONS
      page.update(flag)
      styles.selected_style = style_o
    end

    def self.target_calc(target1, target2,target_nbr,i)
      if target1 == target2
        cible = target1
      else
        distance = target1.distance(target2)/target_nbr*i
        vector = target1.vector_to(target2)
        vector.length = distance
        cible = target1 + vector
      end
      puts "cible target1 #{target1} target2 #{target2} num #{i} \/#{target_nbr}"
      return cible
    end


       

    def self.create_camera(group, prefs, targets, curve)
      model = group.model
        
      # Paramètres Convertion
      pi = Math::PI
      convertion_inch_meter = 0.0254

      # Paramètres curve
      curve_vertices = curve.vertices
      cam_num = (curve_vertices.length).to_f
      cam_middle = ((cam_num/2).floor()).to_f
      cam_nbr_part2 = cam_num-cam_middle-1
      ferme = (curve.vertices[0].position == curve.vertices[-1].position ? 1:0)

      # Parametre Cible
      t1 =  (targets["start"] == nil ? nil : model.find_entity_by_persistent_id( targets["start"]))
      t2 = (targets["middle"] == nil ? nil : model.find_entity_by_persistent_id( targets["middle"]))
      t3 = (targets["end"] == nil ? nil : model.find_entity_by_persistent_id( targets["end"]))

      if t1 == nil && t2 == nil && t3 == nil
        target_start = [0,0,0]  
        target_middle = [0,0,0]
        target_end = [0,0,0]

      elsif t1 != nil && t2 == nil && t3 == nil
        target_start = t1.transformation.origin
        target_middle = target_start
        target_end = target_start

      elsif t1 != nil && t2 != nil && t3 == nil
        target_start = t1.transformation.origin
        target_middle = t2.transformation.origin
        target_end = target_middle

      elsif t1 == nil && t2 != nil && t3 == nil
        target_start = t2.transformation.origin
        target_middle = t2.transformation.origin
        target_end = target_middle

      elsif t1 == nil && t2 != nil && t3 != nil
        target_start = t2.transformation.origin
        target_middle = t2.transformation.origin
        target_end = t3.transformation.origin

      elsif t1 == nil && t2 == nil && t3 != nil
        target_start = t3.transformation.origin
        target_middle = t3.transformation.origin
        target_end = t3.transformation.origin

      elsif t1 != nil && t2 != nil && t3 != nil
        target_start = t1.transformation.origin
        target_middle = t2.transformation.origin
        target_end = t3.transformation.origin

      elsif t1 != nil && t2 == nil && t3 != nil
        target_start = t1.transformation.origin
        target_end = t3.transformation.origin
        target_middle = target_calc(target_start, target_end, 2, 1)
      end

      # Paramètres saisies par l'utilisateur
      path_name = prefs['path_name']
      timestamp_start = prefs['timestamp_start'].to_f
      timestamp_middle = prefs['timestamp_middle'].to_f
      timestamp_end = prefs['timestamp_end'].to_f

      timestamp_start_increment = (timestamp_middle-timestamp_start)/cam_middle
      timestamp_end_increment = (timestamp_end-timestamp_middle)/(cam_num-cam_middle)
      
      hour_start = prefs['hour_start'].to_f
      hour_middle = prefs['hour_middle'].to_f
      hour_end = prefs['hour_end'].to_f

      hour_start_increment = (hour_middle-hour_start)/cam_middle
      hour_end_increment = (hour_end-hour_middle)/(cam_num-cam_middle)

      fieldOfViewDeg = prefs['fieldOfViewRad']
      fieldOfViewRad = (prefs['fieldOfViewRad']*(2*pi)/360).round(6)

      focalPoint = (prefs['focalPoint'] == TRANSLATE["Yes"] ? 1:0)

      mode = prefs['mode']

      addScene = (prefs['addScene'] == TRANSLATE["Yes"] ? 1:0)
      prefixScene = prefs['prefixScene']
      
      #on efface les scenes
      scenes_pid = erase_scenes(group)
      # On initialise les  variables de date à des paramètres d'ombre actuel du modèle
      year = model.shadow_info['ShadowTime'].year
      month = model.shadow_info['ShadowTime'].month
      day = model.shadow_info['ShadowTime'].day
      # On active les ombres
      model.shadow_info["DisplayShadows"] = true
      compteur_scene = 0

      
      
      

    

      # Initialisation de la boucle
      i = 0 #compteur
      timestamp = 0
      doc =""
      view = model.active_view
      keyframes = []
      

      # Boucle sur chaque vertices
      while i  < cam_num

        if ferme == 1 && i == cam_num-1
          cam_next = curve.vertices[1].position
        elsif ferme == 0 && i == cam_num-1
          cam_pre = curve.vertices[i-1].position
          cam = curve.vertices[i].position
          vect = cam_pre.vector_to(cam)
          cam_next = cam + vect
        else
          cam_next = curve.vertices[i+1].position
        end

        if i == 0
          hour = hour_start
          delay_times = timestamp_start
          type = 0
          cible = target_start

        elsif i < cam_middle
          hour = hour_start + ( i* hour_start_increment)
          delay_times = (timestamp_start + ( i * timestamp_start_increment))
          type = 1
          cible = target_calc(target_start, target_middle, cam_middle, i)
        elsif i == cam_middle
          hour = hour_middle
          delay_times = timestamp_middle
          type = 2
          cible = target_middle
        elsif i == cam_num-1
          hour = hour_end
          delay_times = timestamp_end
          type = 3
          cible = target_end  
        elsif i > cam_middle && i<cam_num-1
          hour = hour_middle + ( (i-cam_middle)* hour_end_increment)
          delay_times = (timestamp_middle + ( (i-cam_middle) * timestamp_end_increment))
          type = 1
          cible = target_calc(target_middle, target_end, cam_nbr_part2, i-cam_middle)             
        end

        # Gestion des arrondis
        hour = hour.round(3)
        delay_times = delay_times.round(3)

        timestamp = timestamp + delay_times



        # Camera et vecteur selon le mode
        case mode
          when TRANSLATE['Forward']
            cam = curve.vertices[i].position
            vector = cam.vector_to(cam_next)
            focal_cible = cam + vector
            cam_target_view = 0
          when TRANSLATE['Reverse']
            cam = curve.vertices[i].position
            vector = cam_next.vector_to(cam)
            focal_cible = cam + vector
            cam_target_view = 0
          when TRANSLATE['Traveling']
            cam = curve.vertices[i].position
            vector = cam.vector_to(cible)
            focal_cible = cible
            cam_target_view = 1
          else
            cam = cible
            focal_cible = curve.vertices[i].position
            vector = cible.vector_to (focal_cible)
            cam_target_view = 1
        end
        
    
        lookat_x = (vector.x * convertion_inch_meter).round(6)
        lookat_y = (vector.z * convertion_inch_meter).round(6) #Permutation des axes Z et Y
        lookat_z = -(vector.y * convertion_inch_meter).round(6) #Permutation des axes Z et Y
        
        eye = cam # position de la camera
        position_x = (eye.x * convertion_inch_meter).round(6)
        position_y = (eye.z * convertion_inch_meter).round(6) #Permutation des axes Z et Y
        position_z = -(eye.y * convertion_inch_meter).round(6) #Permutation des axes Z et Y

        focal_inch = cam.distance(focal_cible)
          focal_dc = focal_inch.to_f
        if focalPoint == 1          
          focal_distance = (focal_inch * convertion_inch_meter).round(6)
          focal = (focal_distance>0? "focalPoint=\"#{focal_distance}\" ":"")
        else
          focal = ""
        end

        
        #puts "i #{i}"
        #puts "delay_times #{delay_times}"

        

        # On place le composant camera
        
        camera = place_camera(group,cam,focal_cible) 
        dcdict = "dynamic_attributes"
        camera.set_attribute(dcdict, "a_path", path_name)
        camera.set_attribute(dcdict, "a_pathmode", mode)
        camera.set_attribute(dcdict, "a_pathorder", i)
        camera.set_attribute(dcdict, "a_pathordertype", type)
        camera.set_attribute(dcdict, "a_timestamp", delay_times)
        camera.set_attribute(dcdict, "b_hours", hour)
        camera.set_attribute(dcdict, "c_fieldofview", fieldOfViewDeg)
        camera.set_attribute(dcdict, "c_focalpoint", focal_dc)
        camera.set_attribute(dcdict, "d_show_target",cam_target_view)
                  

        if addScene == 1
          target_scene = eye + vector
          axeZ = model.axes.zaxis
          name = prefixScene + sprintf('%03i', compteur_scene) #nom de la scene prefix + compteur sur 3 digits
          view.camera.set(eye, target_scene, axeZ)
          h = hour.to_i
          min = (hour.to_f-h)*60
          time = Time.local(year, month, day, h, min)
          model.shadow_info['ShadowTime'] = time
          page = model.pages.add name
          page.transition_time = delay_times
          page.delay_time = 0
          page_pid = page.persistent_id
          scenes_pid << page_pid

          camera.set_attribute(dcdict,"b_scene", name)
        end

        dc = $dc_observers.get_latest_class
        dc.redraw_with_undo(camera)

        keyframe = {"order"=> i,"camera"=> camera.persistent_id, "scene"=>name, "hour"=> hour, "fieldOfViewRad"=> fieldOfViewRad, "focal"=> focal_distance, "delay_times"=> delay_times, "timestamp"=>timestamp,"position"=>{"x"=>position_x,"y"=>position_y,"z"=>position_z,},"lookat"=>{"x"=>lookat_x,"y"=>lookat_y,"z"=>lookat_z}}
        keyframes << keyframe
        
        i +=1 #On incrémente le compteur
        compteur_scene +=1 #On incrémente le compteur du nom de scène
      end # Fin de la boucle

      # Placement du texte et de la couleur de la courbe
      text = create_text(group, curve, mode, path_name)

      # Placement du composant direction
      cam1 = curve.vertices[0].position
      cam2 = curve.vertices[1].position
      direction = place_direction(group,cam1,cam2) 

      direction_pid = direction.persistent_id

      
      curve_pid = curve.persistent_id
      videopath = {"count"=> cam_num, "durationSeconds"=> timestamp,} 
      
      group.set_attribute(CDICT, "keyframes", keyframes.to_json)
      group.set_attribute(CDICT, "videopath", videopath.to_json)
      group.set_attribute(CDICT, "curve_pid", curve_pid)
      group.set_attribute(CDICT, "cible_pid", targets.to_json)
      group.set_attribute(CDICT, "direction_pid", direction_pid)
      group.set_attribute(CDICT, "scenes_pid", scenes_pid)
      group.name = path_name

      return path_name      
      
    end #fin de create_xml_file()

    def self.place_camera(group,cam_point,target)
      model = Sketchup.active_model
      cam_def = model.definitions.select{|d| d.name=="Camera"}[0]
      if cam_def == nil
        url = Sketchup.find_support_file("Camera.skp", "Plugins/" + FOLDER + "/skp/")
        cam_def = model.definitions.load(url)
      end
      
       # a vector from start to end
       axis1 = cam_point.vector_to(target) 

       # create a plane perpendicular to axis1
       plane1 = [cam_point, axis1]
 
       # define a second plane parallel to the X_Y plane at Z height
       plane2 =  [[0, 0, target.z] , Z_AXIS]
 
       # find the intersection of the two planes and calculate the cross product.
       # Note that if we are drawing on the Z_axis we use the X_AXIS for axis2
       line = Geom.intersect_plane_plane(plane1, plane2)
       axis2 = line.nil? ? X_AXIS : line[1]
       axis3 = axis1 * axis2
       
       tr = Geom::Transformation.axes(ORIGIN, axis1, axis2.reverse, axis3.reverse)
       tr = Geom::Transformation.translation(cam_point) * tr


      camera = group.entities.add_instance(cam_def,tr)
      camera_focal_point = model.layers.select{|l| l.name == "camera_focal_point"}[0]
      camera_focal_point.line_style = model.line_styles["Dot"]
      return camera
    end

    def self.place_direction(group,cam1,cam2)
      model = Sketchup.active_model
      direction_def = model.definitions.select{|d| d.name=="Direction"}[0]
      if direction_def == nil
        url = Sketchup.find_support_file("Direction.skp", "Plugins/" + FOLDER + "/skp/")
        direction_def = model.definitions.load(url)
      end
     
       # a vector from start to end
       distance = cam1.distance(cam2)/2
       puts distance
       cam_vector = cam1.vector_to(cam2)
       puts cam_vector
       cam_vector.length = distance
       middle = cam1 + cam_vector
       axis1 = middle.vector_to(cam2)

       # create a plane perpendicular to axis1
       plane1 = [middle, axis1]
 
       # define a second plane parallel to the X_Y plane at Z height
       plane2 =  [[0, 0, cam2.z] , Z_AXIS]
 
       # find the intersection of the two planes and calculate the cross product.
       # Note that if we are drawing on the Z_axis we use the X_AXIS for axis2
       line = Geom.intersect_plane_plane(plane1, plane2)
       axis2 = line.nil? ? X_AXIS : line[1]
       axis3 = axis1 * axis2
       
       tr = Geom::Transformation.axes(ORIGIN, axis1, axis2.reverse, axis3.reverse)
       tr = Geom::Transformation.translation(middle) * tr


      direction = group.entities.add_instance(direction_def,tr)
      return direction
      
    end

    def self.curve_to_enscape_path_video_cmd

      model = Sketchup.active_model
      sel = Sketchup.active_model.selection
      edges = sel.grep(Sketchup::Edge)
      if edges[0].curve == nil
          message_texte = TRANSLATE["A curve is required."]+"\n"+TRANSLATE["Operation canceled."]
          message  = UI.messagebox(message_texte, MB_OK)
          
      else
        # Début de la pile d'annulation
        model.start_operation('Curve to Enscape path video',true,false,false)

        # On recuère la courbe originale
        curve_o = edges[0].curve
        # On récupère le tableau de la position de chaque points de la courbe
        points = curve_o.vertices.map{|v| v.position}
        # On récupère l'entité parent
        parent = edges[0].parent
        if parent.class == Sketchup::ComponentInstance
          ents = parent.definition.entities
        else
          ents = parent.entities
        end
        # On créer un nouveau group
        grp = ents.add_group
        grp_ents = grp.entities
        # On recréer la courbe avec le tableau de points
        edges_n = grp_ents.add_curve(points)
        curve = edges_n[0].curve
        puts curve
        # on efface la courbe originale
        curve_o.edges.each{|e| e.erase!}
        # On place le groupe sur le calque "Camera_Path"
        path_layer = Sketchup.active_model.layers.add("Camera_Path")
        behavior = LAYER_HIDDEN_BY_DEFAULT | LAYER_IS_HIDDEN_ON_NEW_PAGES
        path_layer.page_behavior = behavior
        grp.layer = path_layer


        # On creer une scène Enscape Path Video si elle n'existe pas
        if model.pages.length == 0 || model.pages.select{|p| p.name == 'Enscape Path Video'} == []
        model.shadow_info["DisplayShadows"] = false # On desactive les ombres
        page_enscape_video_path = model.pages.add('Enscape Path Video') # on creer la scene
        page_enscape_video_path.set_visibility(path_layer, true) # On rend visible le calque "Camera_Path"
        page_enscape_video_path.include_in_animation = false # On n'inclue pas la scene dans l'annimation

        # charger et appliquer le style à la scene
        add_style(page_enscape_video_path)

        else 
          page_enscape_video_path = model.pages.select{|p| p.name == 'Enscape Path Video'}[0] # on retrouve la scène si elle existe déja
        end

        # On test si la selection contient un composant en guise de cible
        compos = sel.grep(Sketchup::ComponentInstance)
        # On initialise cible_pid
        cible_pid = {'start'=>nil,'middle'=>nil,'end'=>nil}

        if sel.grep(Sketchup::ComponentInstance).length > 0
          targets_o = compos.select{|inst| inst.get_attribute(CDICT,'target_position', nil) != nil}          

          if targets_o.length > 0
            cible_pid = JSON.parse(grp.get_attribute(CDICT, "cible_pid", '{"start":null,"middle":null,"end":null}'))
            target_layer = Sketchup.active_model.layers.add("Camera_Target")

            targets_o.each do |target_o|
              # On récupère la définition
              target_o_def = target_o.definition
              # On récupère son attribut position
              position = target_o.get_attribute(CDICT,'target_position', nil)
              # On récupère la position de l'origine du composant
              origin = target_o.transformation.origin
              # On place une nouvel instance dans le groupe
              target = grp_ents.add_instance(target_o_def,origin)
              # On efface le composant original
              target_o.erase!
              # On redefini les attributs
              target.set_attribute(CDICT,'target_position', position)
              # On redefini les attributs dynamiques
              target.set_attribute("dynamic_attributes","position",position)
							dc = $dc_observers.get_latest_class
        			dc.redraw_with_undo(target)
              # On place l'instance sur le calque "Camera_Target"
              target.layer = target_layer
              #On récupère l'identifiant unique
              target_pid = target.persistent_id

              #On definit selon la position le tableau target
              if position == 1 || position == 12 || position == 123
                cible_pid['start'] = target_pid
              end
              if position == 2 || position == 12 || position == 23 || position == 123
                cible_pid['middle'] = target_pid
              end
              if position == 3 || position == 23 || position == 123
                cible_pid['end'] = target_pid
              end
            end #fin de la boucle sur les target_o

            #On definit l'attribut cible_pid du group
            grp.set_attribute(CDICT, "cible_pid", cible_pid.to_json)

            
          end
        end
        targets = cible_pid

        cam_num = points.length
        # Test si la courbe est féermée
        ferme = (points[0] == points[-1] ? 1:0)
                            
        # On récupère les préférences utilisateur
        prefs = preferences_path(grp, targets, cam_num)

        # Si l'utilisateur à bien valider le formulaire
        unless prefs == {}
          # On déclenche la creation des cameras
          #create_camera(group, prefs, cible, curve)
          status = create_camera(grp, prefs, targets, curve)

          # On active la scene "Enscape video path"
          model.pages.selected_page = page_enscape_video_path
          zoom_paths(page_enscape_video_path)
          # Message de succès
          message_texte = TRANSLATE["The video path group was successfully generated :"] + "\n#{status}"
          message  = UI.messagebox(message_texte, MB_OK)                            
        end

        #on met fin à l'opération
        model.commit_operation         
      end
    end



    def self.config_camera(camera,path_name,path_order,type,timestamp,hours,field_of_view_degres,focal_point)
      dcdict = "dynamic_attributes"
      camera.set_attribute(dcdict, "a_path", path_name)
      camera.set_attribute(dcdict, "a_pathorder", path_order)
      camera.set_attribute(dcdict, "a_pathordertype", type)
      camera.set_attribute(dcdict, "a_timestamp", timestamp)
      camera.set_attribute(dcdict, "b_hours", hours)
      camera.set_attribute(dcdict, "c_fieldofview", fielOfView_degres)
      camera.set_attribute(dcdict, "c_focalpoint", focal_point)
      dc = $dc_observers.get_latest_class
      dc.redraw_with_undo(camera)
    end

    def self.test_group_valid(grp, prefs, curve_pid, cible_pid)
      model = Sketchup.active_model
      erreur = nil
      valide = {}
      curve = nil

      # Test du group et des préférences
      if grp == nil || prefs == {}
              message_texte = TRANSLATE["A group video path is required !"] +"\n"+TRANSLATE["Operation canceled."]
              message  = UI.messagebox(message_texte, MB_OK)
              return erreur
      else
        # Test de la cible enregistrée
        if cible_pid != {'start'=>nil,'middle'=>nil, 'end'=>nil} && model.find_entity_by_persistent_id(cible_pid['start']) == nil && model.find_entity_by_persistent_id(cible_pid['middle']) == nil && model.find_entity_by_persistent_id(cible_pid['end']) == nil
          return erreur
        else
          valide['cible'] = cible_pid 

          # Si la courbe enregistée n'est pas trouvée on selectionne la premiere courbe trouvée  
          if model.find_entity_by_persistent_id(curve_pid) == nil
            grp.entities.grep(Sketchup::Edge).each  do |e| 
              curve = e.curve
              if curve != nil
                break
              end
            end
            # Si aucune courbe est trouvée        
            if curve == nil
              message_texte = TRANSLATE["Video path curve not found !"] +"\n"+TRANSLATE["Operation canceled."]
              message  = UI.messagebox(message_texte, MB_OK)
              return erreur

            else
              valide['curve'] = curve
              return valide
            end

          else 
            valide['curve'] = model.find_entity_by_persistent_id(curve_pid)
            return valide

          end
        end
      end
      
    end

    def self.modifier_path_parameters_cmd
      # Récupération et initialisation des variables
      model = Sketchup.active_model
      sel = model.selection
      grp = sel.grep(Sketchup::Group)[0]
      pid = grp.persistent_id
      prefs = JSON.parse(model.get_attribute( CDICT, pid, "{}"))
      curve_pid = grp.get_attribute(CDICT, "curve_pid", nil)
      cible_pid = JSON.parse(grp.get_attribute(CDICT, "cible_pid", '{"start":null,"middle":null,"end":null}'))

      # Test de validité de la selection
      valide = test_group_valid(grp, prefs, curve_pid, cible_pid)
      unless valide == nil
        curve = valide['curve']
        cible_pid = valide['cible']
        points = curve.vertices.map{|v| v.position}
        cam_num = points.length

        # Début de la pile d'annulation
        model.start_operation('Modify Enscape path video',true,false,false)

        # On creer une scène Enscape Path Video si elle n'existe pas
        if model.pages.length == 0 || model.pages.select{|p| p.name == 'Enscape Path Video'} == []
        model.shadow_info["DisplayShadows"] = false # On desactive les ombres
        page_enscape_video_path = model.pages.add('Enscape Path Video') # on creer la scene
        path_layer = model.layers.select{|l| l.name == "Camera_Path" }
        page_enscape_video_path.set_visibility(path_layer, true) # On rend visible le calque "Camera_Path"
        page_enscape_video_path.include_in_animation = false # On n'inclue pas la scene dans l'annimation

        # charger et appliquer le style à la scene
        add_style(page_enscape_video_path)

        else 
          page_enscape_video_path = model.pages.select{|p| p.name == 'Enscape Path Video'}[0] # on retrouve la scène si elle existe déja
        end
                            
        # On récupère les préférences utilisateur
        prefs_new = preferences_path(grp, cible_pid, cam_num)
        unless prefs_new == {}
           # On efface les anciennes cameras
           keyframes_o = JSON.parse(grp.get_attribute( CDICT, "keyframes", "{}"))
           camera_o_pid = keyframes_o.map{|k| k["camera"]}
           cameras_o = model.find_entity_by_persistent_id(camera_o_pid)
           cameras_o.each{|c| c.erase! if c.valid?}
 
           # On efface l'ancien composant direction
           direction_pid = grp.get_attribute(CDICT, "direction_pid", nil)
           direction = model.find_entity_by_persistent_id(direction_pid)
           direction.erase!
 
          # On déclenche la creation des cameras
          #create_camera(group, prefs, cible, curve)
          status = create_camera(grp, prefs_new, cible_pid, curve)
          # On active la scene "Enscape video path"
          model.pages.selected_page = page_enscape_video_path
          zoom_paths(page_enscape_video_path)
          # Message de succès
          message_texte = TRANSLATE["The video path group was successfully generated :"] + "\n#{status}"
          message  = UI.messagebox(message_texte, MB_OK)                            
        end
        #on met fin à l'opération
        model.commit_operation  
      end
    end

    def self.zoom_paths(page)
      model = Sketchup.active_model
      view = model.active_view
      attrdict = model.attribute_dictionaries[CDICT]
      pids = attrdict.keys
      paths = pids.map{|pid| model.find_entity_by_persistent_id(pid.to_i)}
      new_view = view.zoom paths
      flags = PAGE_USE_CAMERA
      status = page.update(flags)
    end
      



    def self.modifier_curve_sens_cmd
      # Récupération et initialisation des variables
      model = Sketchup.active_model
      sel = model.selection
      grp = sel.grep(Sketchup::Group)[0]
      pid = grp.persistent_id
      prefs = JSON.parse(model.get_attribute( CDICT, pid, "{}"))
      curve_pid = grp.get_attribute(CDICT, "curve_pid", nil)
      cible_pid = JSON.parse(grp.get_attribute(CDICT, "cible_pid", '{"start":null,"middle":null,"end":null}'))

      # Test de validité de la selection
      valide = test_group_valid(grp, prefs, curve_pid, cible_pid)
      unless valide == nil
        curve_o = valide['curve']
        cible = valide['cible']
        direction_pid = grp.get_attribute(CDICT, "direction_pid", nil)
        addScene = (prefs['addScene'] == TRANSLATE["Yes"] ? 1:0)
        prefixScene = prefs['prefixScene']      

        # La courbe est close ou ouverte
        ferme = (curve_o.vertices[0].position == curve_o.vertices[-1].position ? 1:0)

        # Libellé pour les champs de la boîte de dialogue
        prompt = [
          TRANSLATE["Reverse the direction of the curve ?"],
          TRANSLATE["Offset the start point of the curve ?"]
        ]

        # On creer la liste d'option pour le décalage du point de départ
        if ferme == 0
          decalage_liste = 0
        else
          n = curve_o.vertices.length-1
          m = -n+1
          index = []
          for i in m...n
            index << i
          end
          decalage_liste = index.join("|")
        end

        # Liste d'options pour la boite de dialogue
        liste = [
          TRANSLATE['Yes']+'|'+TRANSLATE['No'],
          decalage_liste
        ]
        # Valeur par défaults pour la boite de dialogue
        default = [
          TRANSLATE['No'],
          0
        ]
        # Titre de la boite de dialogue
        titre = TRANSLATE["Change the start point of the curve"]

        #On creer la boite de dialogue
        input = UI.inputbox(prompt, default, liste, titre)

        # Si l'utilisateur a validé la boite de dialogue
        unless input == false

          if model.pages.length == 0 || model.pages.select{|p| p.name == 'Enscape Path Video'} == []
            model.shadow_info["DisplayShadows"] = false # On desactive les ombres
            page_enscape_video_path = model.pages.add('Enscape Path Video') # on creer la scene
            path_layer = model.layers.select{|l| l.name == "Camera_Path" }
            page_enscape_video_path.set_visibility(path_layer, true) # On rend visible le calque "Camera_Path"
            page_enscape_video_path.include_in_animation = false # On n'inclue pas la scene dans l'annimation

            # charger et appliquer le style à la scene
            add_style(page_enscape_video_path)

          else 
            page_enscape_video_path = model.pages.select{|p| p.name == 'Enscape Path Video'}[0] # on retrouve la scène si elle existe déja
          end

          #On récupère les valeurs de la boite
          reverse = (input[0]  == TRANSLATE["Yes"] ? 1:0)
          offset = input[1].to_i

          # On récupère le tableau de point de l'ancienne courbe
          points_o = curve_o.vertices.map{|v| v.position}

          # On modifie l'ordre des points de la courbe

          if reverse == 1 && offset == 0
            points = points_o.reverse
          elsif reverse == 0 && offset > 0
            offset = offset - 1
            points_o.slice!(-1)
            points_a = points_o.slice(0..offset)
            points = points_o - points_a + points_a
            points_0 = points[0]
            points << points_0
          elsif reverse == 1 && offset > 0
            points_o.slice!(-1)
            points_a = points_o.slice(0..offset)
            points = points_o - points_a + points_a
            points.reverse!
            points_0 = points[0]
            points << points_0            
          elsif reverse == 0 && offset < 0
            points_o.slice!(-1)
            points_a = points_o.slice(offset..-1)
            points = points_a + (points_o - points_a)
            points_0 = points[0]
            points << points_0
          elsif reverse == 1 && offset < 0
            points_o.slice!(-1)
            offset = offset + 1
            points_a = points_o.slice(offset..-1)
            points = points_a + (points_o - points_a)
            points.reverse!
            points_0 = points[0]
            points << points_0
          else
            points = points_o
          end

          # On efface l'ancienne courbe
          curve_o.edges.each{|e| e.erase! if e.valid?}
          # on redessine la nouvelle courbe
          edges = grp.entities.add_curve(points)
          curve = edges[0].curve
            
          # # on efface les scènes existantes
          #   scenes_pid = erase_scenes(grp)
          #   # on efface les scenes qui commence avec le prefixe et on initialise le compteur à 0
          #   compteur_scene =0 

            # On initialise les  variables de date à des paramètres d'ombre actuel du modèle
            year = model.shadow_info['ShadowTime'].year
            month = model.shadow_info['ShadowTime'].month
            day = model.shadow_info['ShadowTime'].day

            # On active les ombres
            model.shadow_info["DisplayShadows"] = true
          

          # On efface les anciennes cameras
          keyframes_o = JSON.parse(grp.get_attribute( CDICT, "keyframes", "{}"))
          camera_o_pid = keyframes_o.map{|k| k["camera"].to_i}
          cameras_o = model.find_entity_by_persistent_id(camera_o_pid)
          cameras_o.each{|c| c.erase! if c.valid?}

          # On efface l'ancien composant direction
          direction = model.find_entity_by_persistent_id(direction_pid)
          direction.erase!

          # On créer les nouvelles caméras et scène si demandé
          status = create_camera(grp, prefs, cible, curve)

          # On active la scene "Enscape video path"
          model.pages.selected_page = page_enscape_video_path
          zoom_paths(page_enscape_video_path)

          # Message de succès
          message_texte = TRANSLATE["The start point of the curve was successfully modified :"] + "\n#{status}"
          message  = UI.messagebox(message_texte, MB_OK) 
        end # fin unless input == false       
      end # fin test si le groupe est valide et la courbe trouvée
    end # fin commande




            

  end #fin Espace de noms du plugin.
end #fin module espace de nom de l'auteur