# encoding: UTF-8
#
# file "sj_xml_to_enscape_path_video/export.rb"

## Charge tous les scripts dont ce module dépend.
    ## Note: Le chemin est relatif à la racine de tous les plugins.
    require 'sketchup'
    require 'json'
    require 'fileutils'
      
    ## Ajouter ici les fichiers contenant les commandes
        ## Decommenter la ligne
    #require 'sj_attribute_report/NOM DU FICHIER.rb'      #EDIT
      
# Espace de noms de l'auteur.
module SimJoubert
      
  # Espace de noms du plugin.
  module SJ_XML_TO_ENSCAPE_PATH_VIDEO
    
    # Sous module
    module ExportXml
      # Constante du nom du dictionnaire ou seront stockées les préférences de préfix
      CDICT = 'sj_xml_to_enscape_path_video'

      def self.collect_path(group_pids)
        model = Sketchup.active_model
        dicos = model.attribute_dictionaries
        dico = dicos[CDICT] 
        path_pids_save = dico.keys.map{|k| k.to_i}
        path_pids_select = path_pids_save & group_pids
        paths = {}
        path_pids_select.each do |pid|
          prefs = JSON.parse(model.get_attribute( CDICT, pid, "{}"))
          name = prefs['path_name']
          paths[pid] = name
        end

        return paths
      end

      def self.dialogue_order(paths)
        liste = paths.values << TRANSLATE["None"]
        liste_t = liste.join("|")
        prompt_prefix = TRANSLATE["Video path "]

        n = paths.length
        i = 0
        prompts = []
        defaults = []
        listes = []

        while i < n
          prompts[i] = "#{prompt_prefix} #{i+1}"
          listes[i] = liste_t
          defaults[i] = liste[i]

          i +=1
        end
        
        prompts << TRANSLATE['Shacky camera ?']
        listes <<  TRANSLATE['Yes']+'|'+TRANSLATE['No']
        defaults << TRANSLATE['No']

        prompts << TRANSLATE['Easing in out ?']
        listes <<  TRANSLATE['Yes']+'|'+TRANSLATE['No']
        defaults << TRANSLATE['Yes']

        prompts << TRANSLATE['Name of xml file to save ?']
        listes <<  ""
        defaults << TRANSLATE['Combined_curve_paths']

        titre = TRANSLATE["Put in order video paths"]

        input = UI.inputbox(prompts, defaults, listes, titre)

        # Si le bouton cancel est cliqué input = false
        # Donc sauf si input == false
        unless input == false
          ## On récupère les valeurs saisies dans la boîte de dialogue
          combine_paths = {}
          combine_paths['file_name'] = input[-1]
          combine_paths['easingInOut'] = input[-2]
          combine_paths['shakyCam'] = input[-3]
          names = input.slice(0..(n-1))
          names_clean = names.reject{|n| n == TRANSLATE["None"]}
          pids = names_clean.map{|n| paths.invert[n]}
          combine_paths['pids'] = pids

          return combine_paths
        end
      end

      def self.xml_path_pid(pid,timestamp,order,doc)
        model = Sketchup.active_model
        group = model.find_entity_by_persistent_id(pid.to_i)
        keyframes = JSON.parse(group.get_attribute(CDICT,'keyframes',"{}"))

        unless keyframes == {}

          # Initialisation de la boucle
          i = 0 #compteur
          n = keyframes.length        
          

          while i < n
            keyframe = keyframes[i]
            hour = keyframe['hour']
            fieldOfViewRad = keyframe['fieldOfViewRad']
            focal = (keyframe['focal'] == nil ? "" : "focalPoint=\"#{keyframe['focal']}\" ")
            position = keyframe['position']
            position_x = position["x"]
            position_y = position["y"]
            position_z = position["z"]
            lookat = keyframe['lookat']
            lookat_x = lookat["x"]
            lookat_y = lookat["y"]
            lookat_z = lookat["z"]
            delay_times = keyframe['delay_times'].to_f


            doc = doc + <<-XML
                <Keyframe order="#{order}" hour="#{hour}" fieldOfViewRad="#{fieldOfViewRad}" #{focal}timestampSeconds="#{timestamp}">
                <Position x="#{position_x}" y="#{position_y}" z="#{position_z}" />
                <LookAt x="#{lookat_x}" y="#{lookat_y}" z="#{lookat_z}" />
                </Keyframe>
            XML

            order = order + 1
            timestamp = timestamp +  delay_times
            i +=1
          end
        end

        result = {"doc"=>doc, "order"=>order, "timestamp"=>timestamp }
        return result
      end

      def self.xml_combined(combine_paths)
        pids = combine_paths['pids']
        file_name = combine_paths['file_name']
        shakyCam = (combine_paths['shakyCam'] == TRANSLATE["Yes"] ? 1:0)
        easingInOut = (combine_paths['easingInOut'] == TRANSLATE["Yes"] ? 1:0)
        order = 0
        timestamp = 0.to_f
        doc =""
        pids.each do |pid|
          result = xml_path_pid(pid,timestamp,order,doc)
          timestamp = result['timestamp'].to_f
          order = result['order'].to_i
          doc = result['doc']
        end

        #Entête du fichier xml
        doc_entete = <<-XML
        <?xml version="1.0" ?>
        <VideoPath version="1" durationSeconds="#{timestamp}" easingInOut="#{easingInOut}" shakyCam="#{shakyCam}">
        <Keyframes count="#{order}">
        XML

        # On ajoutte au xml la fermeture des balises d'entête
        doc = doc_entete + doc + <<-XML
        </Keyframes>
        </VideoPath>
        XML

        xml = {'file_name'=> file_name, 'doc'=> doc}
        return xml
      end

      def self.create_xml_curve_path_combined_cmd
        model = Sketchup.active_model
        sel = model.selection
        groups = sel.grep(Sketchup::Group)
        
        unless groups == []
          group_pids = groups.map{|g| g.persistent_id}
          puts "group_pids #{group_pids}"
          paths = collect_path(group_pids)
          puts "paths #{paths}"
          combine_paths = dialogue_order(paths)
          puts "combine_paths #{combine_paths}"
          xml = xml_combined(combine_paths)
          puts "xml #{xml}"
          file_name = xml['file_name'] + ".xml"
          doc = xml['doc']

          # Paramètre chemin enregistrement fichier
          mpath = model.path.gsub(".skp","\\")
          url = File.join(mpath, file_name)

          # On test l'existance du dossier portant le m^me nom que le fichier du modele
          if File.directory?(mpath) == false
            #on creer le répertoire avec le nom du modèle s'il n'éxiste pas
            FileUtils.mkdir mpath
          end
        
          #Ecriture du fichier
          File.open(url, 'w') { |file| file.write(doc) }
        
          # Message de succès
          message_texte = TRANSLATE["The file was successfully generated :"] + "\n#{url}"
          message  = UI.messagebox(message_texte, MB_OK)
        end
      end




        


          





      

    end#fin sous module
  end#fin module plugin
end#fin module espace de nom