# encoding: UTF-8
#
# file "sj_xml_to_enscape_path_video/menu.rb"

# Charge tous les scripts dont ce module dépend.
  # Note: Le chemin est relatif à la racine de tous les plugins.
  require 'sketchup'

  ## Ajouter ici les fichiers contenant les commandes
  ## Decommenter la ligne
  require 'sj_xml_to_enscape_path_video/curve_to_enscape_path_video.rb'      #EDIT
  require 'sj_xml_to_enscape_path_video/scenes_to_enscape_path_video.rb'      #EDIT
  require 'sj_xml_to_enscape_path_video/import_component.rb'      #EDIT
  require 'sj_xml_to_enscape_path_video/export_xml.rb'      #EDIT
  require 'sj_xml_to_enscape_path_video/erase_path.rb'      #EDIT
  
  
 # Espace de noms de l'auteur.
module SimJoubert
	#On creer un sous menu SimJoubert Tools dans le menu Plugins ou Extentions
	# S'il n'est pas déjà défini :
	unless const_defined?('AUTHOR_MENU')
		# Ajoute le sous-menu de l'auteur dans le menu des extensions SketchUp.
		AUTHOR_MENU = UI.menu('Plugins').add_submenu('SimJoubert Tools')
		MYPLUGINS_MENU = AUTHOR_MENU.add_submenu("-=My plugins=-")
		MYPLUGINS_MENU.add_item('Discover my plugins') do
		  UI.openURL('https://www.sketchup.simjoubert.com/my-plugins')
		end
		MYPLUGINS_MENU.add_separator
		AUTHOR_MENU.add_separator
	
	end

    # Espace de noms du plugin.
    module SJ_XML_TO_ENSCAPE_PATH_VIDEO 

        # Sous module Menu
    	module Menu

            def self.add
                # lien vers la page du plugin sur le site My sketchup
                plugin_lien = MYPLUGINS_MENU.add_item('page '+ NAME) {UI.openURL "https://www.sketchup.simjoubert.com/1-plugins/8-sj-xml-to-enscape-path-video.html"}

                # Création du sous menu du plugin dans le menu SimJoubert Tools
                plugin_menu = AUTHOR_MENU.add_submenu(MENU_NAME)

                #Ajouter ici les items du plugin dans le sous dossier du plugin MENU_NAME

        		item_1 = plugin_menu.add_item(TRANSLATE["Curve to Enscape path video."]) { SJ_XML_TO_ENSCAPE_PATH_VIDEO.curve_to_enscape_path_video_cmd }
                status_item_1 = plugin_menu.set_validation_proc(item_1)  {
                    test = SJ_XML_TO_ENSCAPE_PATH_VIDEO.validation_proc_curve()                                    
                    if test == false
                        MF_GRAYED
                    else
                        MF_ENABLED
                    end
                }

                item_2 = plugin_menu.add_item(TRANSLATE["Modify curve start point."]) { SJ_XML_TO_ENSCAPE_PATH_VIDEO.modifier_curve_sens_cmd }
                status_item_2 = plugin_menu.set_validation_proc(item_2)  {
                    test = SJ_XML_TO_ENSCAPE_PATH_VIDEO.validation_proc_group(1)                                      
                    if test == false
                        MF_GRAYED
                    else
                        MF_ENABLED
                    end
                }

                item_3 = plugin_menu.add_item(TRANSLATE["Modify path video."]) { SJ_XML_TO_ENSCAPE_PATH_VIDEO.modifier_path_parameters_cmd }
                status_item_3 = plugin_menu.set_validation_proc(item_3)  {
                    test = SJ_XML_TO_ENSCAPE_PATH_VIDEO.validation_proc_group(1)                                      
                    if test == false
                        MF_GRAYED
                    else
                        MF_ENABLED
                    end
                }

                item_4 = plugin_menu.add_item(TRANSLATE["Delete Video path group"]) { SJ_XML_TO_ENSCAPE_PATH_VIDEO::Erase.erase_video_path_group_cmd }
                status_item_4 = plugin_menu.set_validation_proc(item_4)  {
                    test = SJ_XML_TO_ENSCAPE_PATH_VIDEO.validation_proc_group(1)                                      
                    if test == false
                        MF_GRAYED
                    else
                        MF_ENABLED
                    end
                }

                item_5 = plugin_menu.add_item(TRANSLATE["Combine  video paths groups"]) { SJ_XML_TO_ENSCAPE_PATH_VIDEO::ExportXml.create_xml_curve_path_combined_cmd }
                status_item_5 = plugin_menu.set_validation_proc(item_5)  {
                    test = SJ_XML_TO_ENSCAPE_PATH_VIDEO.validation_proc_group()                                      
                    if test == false
                        MF_GRAYED
                    else
                        MF_ENABLED
                    end
                }
                plugin_menu.add_separator

                item_6 = plugin_menu.add_item(TRANSLATE["Place a target component."]) { SJ_XML_TO_ENSCAPE_PATH_VIDEO::ImportComponent.composant_mire_cmd }

                item_7 = plugin_menu.add_item(TRANSLATE["Modify target"]) { SJ_XML_TO_ENSCAPE_PATH_VIDEO::Target.modify_target_cmd }
                status_item_7 = plugin_menu.set_validation_proc(item_7)  {
                    test = SJ_XML_TO_ENSCAPE_PATH_VIDEO::Target.validation_proc_target(1)                                      
                    if test == false
                        MF_GRAYED
                    else
                        MF_ENABLED
                    end
                }                
                
                plugin_menu.add_separator

                item_8 = plugin_menu.add_item(TRANSLATE["Scenes to Enscape path video."]) { SJ_XML_TO_ENSCAPE_PATH_VIDEO.scenes_to_enscape_path_video_cmd }
        		
            end

        end #fin Sous Module Menu
    end #fin Espace de noms du plugin.
end #fin module espace de nom de l'auteur