# encoding: UTF-8
#
# file "sj_xml_to_enscape_path_video/scene_to_enscape_path_video.rb"

## Charge tous les scripts dont ce module dépend.
    ## Note: Le chemin est relatif à la racine de tous les plugins.
    require 'sketchup'
    require 'json'
    require 'fileutils'
      
    ## Ajouter ici les fichiers contenant les commandes
        ## Decommenter la ligne
    #require 'sj_xml_to_enscape_path_video/NOM DU FICHIER.rb'      #EDIT
      
    # Espace de noms de l'auteur.
    module SimJoubert
          
        # Espace de noms du plugin.
        module SJ_XML_TO_ENSCAPE_PATH_VIDEO 

            # Constante du nom du dictionnaire ou seront stockées les préférences de préfix
            SDICT = 'sj_scenes_to_enscape_path_video'

            def self.scenes_preferences_path(model, cam_num)
                
                #on récupère les préférences enregistrée dans le dictionnaire sj_components_to_scenes du model
                prefs =JSON.parse(model.get_attribute( SDICT, 'preferences', "{}"))
                
                if prefs == {}
                    prefs = {
                        'timestamp_start' => 2.0,
                        'timestamp_middle' => 5.0,
                        'timestamp_end' => 2.0,
                        'sceneTransitionTime' =>TRANSLATE['Yes'],
                        'hour_start' => 8.0,
                        'hour_middle' => 14.0,
                        'hour_end' => 22.0,
                        'sceneShadowTime' =>TRANSLATE['Yes'],
                        'fieldOfViewRad' => 60,
                        'shakyCam' => TRANSLATE['No'],
                        'easingInOut' => TRANSLATE['Yes']
                        }
                end
                
                # initialisation formulaire

                prompts = [
                    TRANSLATE['Timestamp start (second)'],
                    TRANSLATE['Timestamp middle (second)'],
                    TRANSLATE['Timestamp end (second)'],
                    TRANSLATE['Use scene transition delay ?'],
                    TRANSLATE['Hour start (hour)'],
                    TRANSLATE['Hour middle (hour)'],
                    TRANSLATE['Hour end (hour)'],
                    TRANSLATE['Use scene time ?'],
                    TRANSLATE['Field of view (degrees)'],
                    TRANSLATE['Shacky camera ?'],
                    TRANSLATE['Easing in out ?']
                ]

                list = [
                    "",
                    "",
                    "",
                    TRANSLATE['Yes']+'|'+TRANSLATE['No'],
                    "",
                    "",
                    "",
                    TRANSLATE['Yes']+'|'+TRANSLATE['No'],
                    "",
                    TRANSLATE['Yes']+'|'+TRANSLATE['No'],
                    TRANSLATE['Yes']+'|'+TRANSLATE['No']
                ]
                defaults = [
                    prefs['timestamp_start'],
                    prefs['timestamp_middle'],
                    prefs['timestamp_end'],
                    prefs['sceneTransitionTime'],
                    prefs['hour_start'],
                    prefs['hour_middle'],
                    prefs['hour_end'],
                    prefs['sceneShadowTime'],
                    prefs['fieldOfViewRad'],
                    prefs['shakyCam'],
                    prefs['easingInOut']
                ]
                titre1 = TRANSLATE["Enscape video path settings"]
                titre2 = TRANSLATE["Keyframes"]
                titre3 = "#{titre1} (#{cam_num.to_s} #{titre2})"
                input = UI.inputbox(prompts, defaults, list, titre3)

                # Si le bouton cancel est cliqué input = false
                # Donc sauf si input == false
                unless input == false
                    ## On récupère les valeurs saisies dans la boîte de dialogue

                    prefs = {
                        'timestamp_start' => input[0],
                        'timestamp_middle' => input[1],
                        'timestamp_end' => input[2],
                        'sceneTransitionTime' =>input[3],
                        'hour_start' => input[4],
                        'hour_middle' => input[5],
                        'hour_end' => input[6],
                        'sceneShadowTime' => input[7],
                        'fieldOfViewRad' => input[8],
                        'shakyCam' => input[9],
                        'easingInOut' => input[10]
                    }

                    #On enregistre les parametres saisiesdans le dictionnaire sj_xml_to_enscape_path_video du model

                    model.set_attribute( SDICT, 'preferences', prefs.to_json)
                    puts "Preferences sauvegardées dans dictionnaire"
                    puts prefs
                else
                    
                    prefs = {}
                    puts "formulaire préferences annuler par l'utilisateur"
                                        
                end
                
                return prefs

            end #fin de preferences_path()



            ######################################################

            def self.scenes_create_xml_file(model, pages_in_animation, prefs, cam_num)
                
                # Paramètre chemin enregistrement fichier
                mpath = model.path.gsub(".skp","\\")
                url = File.join(mpath, "Scenes_Camera_trajectoire.xml")
  
                # Paramètres Convertion
                pi = Math::PI
                convertion_inch_meter = 0.0254

                # Paramètres scenes
                cam_middle = (cam_num/2).to_i

                # Paramètres saisies par l'utilisateur
                timestamp_start = prefs['timestamp_start'].to_f
                timestamp_middle = prefs['timestamp_middle'].to_f
                timestamp_end = prefs['timestamp_end'].to_f

                timestamp_start_increment = (timestamp_middle-timestamp_start)/cam_middle
                timestamp_end_increment = (timestamp_end-timestamp_middle)/(cam_num-cam_middle)

                sceneTransitionTime = (prefs['sceneTransitionTime'] == TRANSLATE["Yes"] ? 1:0)
                
                hour_start = prefs['hour_start'].to_f
                hour_middle = prefs['hour_middle'].to_f
                hour_end = prefs['hour_end'].to_f

                hour_start_increment = (hour_middle-hour_start)/cam_middle
                hour_end_increment = (hour_end-hour_middle)/(cam_num-cam_middle)

                sceneShadowTime = (prefs['sceneShadowTime'] == TRANSLATE["Yes"] ? 1:0)
                
                fieldOfViewRad = (prefs['fieldOfViewRad']*(2*pi)/360).round(6)
                shakyCam = (prefs['shakyCam'] == TRANSLATE["Yes"] ? 1:0)
                easingInOut =(prefs['easingInOut'] == TRANSLATE["Yes"] ? 1:0)

                # Début de la pile d'annulation
                model.start_operation('Scenes to Enscape path video',true,false,false)

                # Initialisation de la boucle
                i = 0 #compteur
                timestamp = 0
                doc =""

                # Boucle sur chaque edges
                while i  < cam_num
                    page = pages_in_animation[i]
                    cam = page.camera
                    vector = cam.direction 
                                    
                    lookat_x = (vector.x * convertion_inch_meter).round(6)
                    lookat_y = (vector.z * convertion_inch_meter).round(6) #Permutation des axes Z et Y
                    lookat_z = -(vector.y * convertion_inch_meter).round(6) #Permutation des axes Z et Y
                    
                    # position de la camera
                    eye = cam.eye
                    position_x = (eye.x * convertion_inch_meter).round(6)
                    position_y = (eye.z * convertion_inch_meter).round(6) #Permutation des axes Z et Y
                    position_z = -(eye.y * convertion_inch_meter).round(6) #Permutation des axes Z et Y
                    # if i < cam_middle
                    #     hour = hour_start + ( i* hour_start_increment)
                    #     timestamp = timestamp + (timestamp_start+ ( i * timestamp_start_increment))
                    # elsif i == cam_middle
                    #     hour = hour_middle
                    #     timestamp = timestamp + timestamp_middle
                    # else
                    #     hour = hour_middle + ( (i-cam_middle)* hour_end_increment)
                    #     timestamp = timestamp + (timestamp_middle + ( (i-cam_middle) * timestamp_end_increment))
                        
                    # end

                     
                    
                    if page.use_shadow_info? == true && sceneShadowTime == 1
                        time = page.shadow_info['ShadowTime']
                        h = (time.hour).to_f
                        min = (time.min).to_f/60
                        hour = h + min
                    elsif i < cam_middle
                        hour = hour_start + ( i* hour_start_increment)
                    elsif i == cam_middle
                        hour = hour_middle
                    else
                        hour = hour_middle + ( (i-cam_middle)* hour_end_increment)
                    end

                    if page.transition_time > 0 && sceneTransitionTime == 1
                        timestamp = timestamp + page.transition_time
                    elsif i < cam_middle
                        timestamp = timestamp + (timestamp_start+ ( i * timestamp_start_increment))
                    elsif i == cam_middle
                        timestamp = timestamp + timestamp_middle
                    else
                        timestamp = timestamp + (timestamp_middle + ( (i-cam_middle) * timestamp_end_increment))
                    end

                   
                
                    # On ajoute à la chaine xml les paramètre de keyframe propre à la scène
                    doc = doc + <<-XML
                        <Keyframe order="#{i}" hour="#{hour}" fieldOfViewRad="#{fieldOfViewRad}" timestampSeconds="#{timestamp}">
                        <Position x="#{position_x}" y="#{position_y}" z="#{position_z}" />
                        <LookAt x="#{lookat_x}" y="#{lookat_y}" z="#{lookat_z}" />
                        </Keyframe>
                    XML
                    
                    i +=1 #On incrémente le compteur
                end # Fin de la boucle
                
                               
                #Entête du fichier xml
                doc_entete = <<-XML
                <?xml version="1.0" ?>
                <VideoPath version="1" durationSeconds="#{timestamp}" easingInOut="#{easingInOut}" shakyCam="#{shakyCam}">
                <Keyframes count="#{cam_num}">
                XML
            
                # On ajoutte au xml la fermeture des balises d'entête
                doc = doc_entete + doc + <<-XML
                </Keyframes>
                </VideoPath>
                XML

                # On test l'existance du dossier portant le m^me nom que le fichier du modele
                if File.directory?(mpath) == false
                    #on creer le répertoire avec le nom du modèle s'il n'éxiste pas
                    FileUtils.mkdir mpath
                end
                
                #Ecriture du fichier
                File.open(url, 'w') { |file| file.write(doc) }
                
                # Message de succès
                message_texte = TRANSLATE["The file was successfully generated :"] + "\n#{url}"
                message  = UI.messagebox(message_texte, MB_OK)                            

                #on met fin à l'opération
                model.commit_operation
                
            end #fin de create_xml_file()


            ######################################################

            def self.scenes_to_enscape_path_video_cmd

                # initialisation des variables
                model = Sketchup.active_model
                pages = model.pages
                pages_in_animation = model.pages.select { |page| page.include_in_animation? }

                if  model.path == "" # Le modèle n'est pas enregistré
                    message_texte = TRANSLATE["Please save your model before, and start again."]+"\n"+TRANSLATE["Operation canceled."]
                    message  = UI.messagebox(message_texte, MB_OK)
                    

                # Test s'il y a des scènes
                elsif pages_in_animation.length < 1
                    message_texte = TRANSLATE["No scenes in the model !"]+"\n"+TRANSLATE["Operation canceled."]
                    message = UI::messagebox( message_texte ,MB_OK )
                   

                else # S'il y a des scenes                  
                                      
                        # On récupère les préférences utilisateur
                        cam_num = pages_in_animation.length
                        prefs = scenes_preferences_path(model, cam_num)

                        # Si l'utilisateur à bien valider le formulaire
                        unless prefs == {}
                            # On déclenche la cre&tion des scènes
                            scenes_create_xml_file(model, pages_in_animation, prefs, cam_num)
                        end

                    
                        
                    
                end
            end # fin de sj_scenes_to_enscape_path_video_cmd

            

        end #fin Espace de noms du plugin.
    end #fin module espace de nom de l'auteur