# encoding: UTF-8
#
# file "sj_xml_to_enscape_path_video/target.rb

## Charge tous les scripts dont ce module dépend.
    ## Note: Le chemin est relatif à la racine de tous les plugins.
    require 'sketchup'
    require 'json'
    require 'fileutils'
      
    ## Ajouter ici les fichiers contenant les commandes
        ## Decommenter la ligne
    #require 'sj_xml_to_enscape_path_video/NOM DU FICHIER.rb'      #EDIT
      
# Espace de noms de l'auteur.
module SimJoubert
      
  # Espace de noms du plugin.
  module SJ_XML_TO_ENSCAPE_PATH_VIDEO
    
    # Sous module
    module Target
      # Constante du nom du dictionnaire ou seront stockées les préférences de préfix
      CDICT = 'sj_xml_to_enscape_path_video'

      def self.validation_proc_target(nbr=0)
        model = Sketchup.active_model
        sel = model.selection
        instances = sel.grep(Sketchup::ComponentInstance)
        return_value = false
        
        if instances.length > 0         
          targets = instances.select{|inst| inst.get_attribute(CDICT, "target_position", nil) != nil}          
          if targets.length > 0
            if nbr == 1
              return_value = targets[0]
            else
              return_value = targets
            end
          end
        end
        return return_value
      end

      def self.dialogue_target(position)
        spaces = "                "#16 espaces pour un meilleur visuel de la boite de dialogue

        position_h = {
          "#{TRANSLATE["Start, Middle, End"]}#{spaces}"=>123,
          "#{TRANSLATE["Start"]}#{spaces}"=>1,
          "#{TRANSLATE["Middle"]}#{spaces}"=>2,
          "#{TRANSLATE["End"]}#{spaces}"=>3,
          "#{TRANSLATE["Middle, End"]}#{spaces}"=>23,
          "#{TRANSLATE["Start, Middle"]}#{spaces}"=>12,
          "#{TRANSLATE["None"]}#{spaces}"=>0
        }


        liste = [position_h.keys.join("|")]
        if position == nil
				  default = ["#{TRANSLATE["Start, Middle, End"]}#{spaces}"]
        else
          default = [position_h.invert[position.to_i]]
        end
				prompt = [TRANSLATE["Target position ?"]]
				titre = TRANSLATE["Define the target position"]

				input = UI.inputbox(prompt, default, liste, titre)
				

				unless input == false
					position_text = input[0]
					position_text = TRANSLATE[position_text]
					position = position_h[position_text]
          position = (position == nil ? 0 : position)
				else
					position = (position == nil ? 0 : 0)
				end
				return position
      end

      def self.modify_attribute(target, position)

        model = Sketchup.active_model
        target_pid = target.persistent_id
        parent = target.parent
				
        unless parent == model
          if parent.group? == true
            grp = parent.instances[0]
            grp_pid = grp.persistent_id
            pref = JSON.parse(model.get_attribute( CDICT, grp_pid, "{}"))
            cible_pid = JSON.parse(grp.get_attribute(CDICT, "cible_pid", '{"start":null,"middle":null,"end":null}'))

            if pref != {} 
              
                if cible_pid['start'] == target_pid
                  cible_pid['start'] = nil
                end
                if cible_pid['end'] == target_pid
                  cible_pid['end'] = nil
                end
                if cible_pid['middle'] == target_pid
                  cible_pid['middle'] = nil
                end
              

              if position == 1 || position == 12 || position == 123
                cible_pid['start'] = target_pid
              end
              if position == 2 || position == 12 || position == 23 || position == 123
                cible_pid['middle'] = target_pid
              end
              if position == 3 || position == 23 || position == 123
                cible_pid['end'] = target_pid
              end
              grp.set_attribute(CDICT, "cible_pid", cible_pid.to_json)
              
            end
          end
        end
        target.set_attribute(CDICT,'target_position', position)
        target.set_attribute("dynamic_attributes","position", position)
        dc = $dc_observers.get_latest_class
        dc.redraw_with_undo(target)
        
      end

      def self.modify_target_cmd
        model = Sketchup.active_model
        #On test la selection et on recupère la premiere target de la sélection
        target = validation_proc_target(1)
        puts "target #{target}"
        unless target == false
          # on récupère l'ancien attributs position
          position_o = target.get_attribute(CDICT,'target_position',nil)
          puts "position old #{position_o}"
          # Dialogue on récupère la nouvelle position de la cible
          position_n = dialogue_target(position_o)
          puts "position new #{position_n}"
          # modification des attributs
          model.start_operation(TRANSLATE["Modify target"],true,false,false)
          modify_attribute(target, position_n)
          model.commit_operation
        end
      end


    end#fin sous module
  end#fin module plugin
end#fin module espace de nom