# encoding: UTF-8
#
# file "sj_xml_to_enscape_path_video/toolbar.rb"

## Charge tous les scripts dont ce module dépend.
    ## Note: Le chemin est relatif à la racine de tous les plugins.
    require 'sketchup'

    ## Ajouter ici les fichiers contenant les commandes
        ## Decommenter la ligne
    require 'sj_xml_to_enscape_path_video/curve_to_enscape_path_video.rb'      #EDIT
    require 'sj_xml_to_enscape_path_video/scenes_to_enscape_path_video.rb'      #EDIT
    require 'sj_xml_to_enscape_path_video/import_component.rb'      #EDIT
    require 'sj_xml_to_enscape_path_video/export_xml.rb'      #EDIT
    require 'sj_xml_to_enscape_path_video/erase_path.rb'      #EDIT
    require 'sj_xml_to_enscape_path_video/target.rb'      #EDIT

    # Espace de noms de l'auteur.
    module SimJoubert
          
        # Espace de noms du plugin.
        module SJ_XML_TO_ENSCAPE_PATH_VIDEO
      
            #Sous Module Toolbar
            module Toolbar
      
                # Chemin absolu vers le dossier des icônes de la barre d'outils.
                ICONS_DIR = File.join(__dir__, 'Toolbar_icons')
    
                # Retourne la bonne extension pour une icône de la barre d'outils en fonction de l'OS (macOS, Windows).
                #
                # @return [String]
                def self.icon_extension
                Sketchup.platform == :platform_osx ? 'pdf' : 'svg'
                end
    
                def self.add
                    toolbar = UI::Toolbar.new(TOOLBAR_NAME)
    
                    # Ajouter ici la commandes accessible dans la barre outils                
                    command = UI::Command.new(MENU_NAME) {SJ_XML_TO_ENSCAPE_PATH_VIDEO.curve_to_enscape_path_video_cmd}       #EDIT s'il ya plusieurs commandes remplacer MENU NAME par le nom de la commande
                    command.small_icon = command.large_icon = File.join(ICONS_DIR, "curve-01.#{icon_extension}")       #EDIT
                    command.tooltip = TRANSLATE["Curve to Enscape path video."]       #EDIT
                    command.status_bar_text =  TRANSLATE["Convert the selected curve into a group of video paths. Each point of the curve into keyframes. The created group will be editable and configurable. Transition delays, time of day... Creating scenes for each keyframe. Select a curve and a target component first."]       #EDIT
                    command.set_validation_proc {
                        test = SJ_XML_TO_ENSCAPE_PATH_VIDEO.validation_proc_curve()                                       

                        if test == false
                            MF_GRAYED
                        else
                            MF_ENABLED
                        end
                    }
                    toolbar.add_item(command)

                    command3 = UI::Command.new(MENU_NAME) {SJ_XML_TO_ENSCAPE_PATH_VIDEO.modifier_curve_sens_cmd}       #EDIT s'il ya plusieurs commandes remplacer MENU NAME par le nom de la commande
                    command3.small_icon = command3.large_icon = File.join(ICONS_DIR, "curve-start1.#{icon_extension}")       #EDIT
                    command3.tooltip = TRANSLATE["Modify curve start point."]       #EDIT
                    command3.status_bar_text =  TRANSLATE["Change the start point of the curve, by reversing the direction of the curve. If the curve is closed, you can also offset the start point. First select a video path group before!"]       #EDIT
                    command3.set_validation_proc {
                        test = SJ_XML_TO_ENSCAPE_PATH_VIDEO.validation_proc_group(1)                                       

                        if test == false
                            MF_GRAYED
                        else
                            MF_ENABLED
                        end
                    }
                    toolbar.add_item(command3)

                    command5 = UI::Command.new(MENU_NAME) {SJ_XML_TO_ENSCAPE_PATH_VIDEO.modifier_path_parameters_cmd}       #EDIT s'il ya plusieurs commandes remplacer MENU NAME par le nom de la commande
                    command5.small_icon = command5.large_icon = File.join(ICONS_DIR, "Mixer.#{icon_extension}")       #EDIT
                    command5.tooltip = TRANSLATE["Modify path video."]       #EDIT
                    command5.status_bar_text =  TRANSLATE["Change video path settings. Select a Video Path Group, before launching the command."]       #EDIT
                    command5.set_validation_proc {
                        test = SJ_XML_TO_ENSCAPE_PATH_VIDEO.validation_proc_group(1)                                       

                        if test == false
                            MF_GRAYED
                        else
                            MF_ENABLED
                        end
                    }
                    toolbar.add_item(command5)

                    

                    command7 = UI::Command.new(MENU_NAME) {SJ_XML_TO_ENSCAPE_PATH_VIDEO::Erase.erase_video_path_group_cmd}       #EDIT s'il ya plusieurs commandes remplacer MENU NAME par le nom de la commande
                    command7.small_icon = command7.large_icon = File.join(ICONS_DIR, "erase_path_group.#{icon_extension}")       #EDIT
                    command7.tooltip = TRANSLATE["Delete Video path group"]       #EDIT
                    command7.status_bar_text =  TRANSLATE["Delete the select video path group and its attributes."]       #EDIT
                    command7.set_validation_proc {
                        test = SJ_XML_TO_ENSCAPE_PATH_VIDEO.validation_proc_group(1)                                       

                        if test == false
                            MF_GRAYED
                        else
                            MF_ENABLED
                        end
                    }
                    toolbar.add_item(command7)
                    

                    

                    command6 = UI::Command.new(MENU_NAME) {SJ_XML_TO_ENSCAPE_PATH_VIDEO::ExportXml.create_xml_curve_path_combined_cmd}       #EDIT s'il ya plusieurs commandes remplacer MENU NAME par le nom de la commande
                    command6.small_icon = command6.large_icon = File.join(ICONS_DIR, "combined_curves_xml.#{icon_extension}")       #EDIT
                    command6.tooltip = TRANSLATE["Combine  video paths groups"]       #EDIT
                    command6.status_bar_text =  TRANSLATE["Select one or more video paths groups. Order them, and export an XML file of the combined paths."]       #EDIT
                    command6.set_validation_proc {
                        test = SJ_XML_TO_ENSCAPE_PATH_VIDEO.validation_proc_group()                                       

                        if test == false
                            MF_GRAYED
                        else
                            MF_ENABLED
                        end
                    }
                    toolbar.add_item(command6)

                    

                    toolbar.add_separator
                    
                    command4 = UI::Command.new(MENU_NAME) {SJ_XML_TO_ENSCAPE_PATH_VIDEO::ImportComponent.composant_mire_cmd}       #EDIT s'il ya plusieurs commandes remplacer MENU NAME par le nom de la commande
                    command4.small_icon = command4.large_icon = File.join(ICONS_DIR, "target.#{icon_extension}")       #EDIT
                    command4.tooltip = TRANSLATE["Place a target component."]       #EDIT
                    command4.status_bar_text =  TRANSLATE["Place a target component."]       #EDIT
                    toolbar.add_item(command4)

                    command8 = UI::Command.new(MENU_NAME) {SJ_XML_TO_ENSCAPE_PATH_VIDEO::Target.modify_target_cmd}       #EDIT s'il ya plusieurs commandes remplacer MENU NAME par le nom de la commande
                    command8.small_icon = command8.large_icon = File.join(ICONS_DIR, "target_edit.#{icon_extension}")       #EDIT
                    command8.tooltip = TRANSLATE["Modify target"]       #EDIT
                    command8.status_bar_text =  TRANSLATE["Modify the target ordering position. Select a target component first."]       #EDIT
                    command8.set_validation_proc {
                        test = SJ_XML_TO_ENSCAPE_PATH_VIDEO::Target.validation_proc_target(1)                                     
                        if test == false
                            MF_GRAYED
                        else
                            MF_ENABLED
                        end
                    }
                    toolbar.add_item(command8)


                    
                    toolbar.add_separator

                    command2 = UI::Command.new(MENU_NAME) {SJ_XML_TO_ENSCAPE_PATH_VIDEO.scenes_to_enscape_path_video_cmd}       #EDIT s'il ya plusieurs commandes remplacer MENU NAME par le nom de la commande
                    command2.small_icon = command2.large_icon = File.join(ICONS_DIR, "scenes-01.#{icon_extension}")       #EDIT
                    command2.tooltip = TRANSLATE["Scenes to Enscape path video."]       #EDIT
                    command2.status_bar_text =  TRANSLATE["Convert each scenes to keyframes, Save the keyframes to an XML file, importable into the Enscape video module."]       #EDIT
                    toolbar.add_item(command2)

                    

                    
                    toolbar.show

                    ##---------------------------------------- PERSONALISATION-----------------------------------------------------
                    ## Décommenter les lignes suivantes pour ajouter la commande dans votre propre barre outils
                    ## Code personalisé Création d'une barre Outil nommé London. Modifier uniquement les paramètres pour les lignes qui comporte une remarque #Edit 

                    #command2 = UI::Command.new(MENU_NAME)  { SJ_COMPONENTSTOSCENES.components_to_scenes_cmd }
                    #command2.tooltip = TRANSLATE["Components to Pages."]
                    #command2.status_bar_text = TRANSLATE["Create scene by definition of selected components. Select one or more instances first."]
                    #command2.small_icon = command.large_icon = File.join(ICONS_DIR, "components2Scenes.#{icon_extension}")       #EDIT idiquer le nom de l'icone sans extension, ajouter votre icone perso dans le dossier toolbar_icons windows format svg et mac format pdf
                    #toolbar2 = UI::Toolbar.new "London"  #EDIT UI::Toolbar.new "le nom de la nouvelle barre outils" ou UI::Toolbar("le nom de la barre existante")
                    #toolbar2 = toolbar2.add_item command2
                    #toolbar2.show

                    ## fin code personalisé
    
    
    
                    
                end
                  
                  
            end #fin Sous Module Toolbar
        end #fin Espace de noms du plugin.
    end #fin module espace de nom de l'auteur